-module(fifostate).
-export([start/0,inc/1,dec/1,show/1,get/1]).

start() -> spawn(fun() -> loop(fifo:new()) end).
loop(Fi) ->
  receive
    inc ->
      % Update the process state by using a new value
      % for the argument to the process loop:
      fifo:push(Fi,o);
    dec ->
      % Update the process state by using a new value
      % for the argument to the process loop:
      fifo:pop(Fi);
    show ->
      io:format(" Size = ~w~n", [fifo:size(Fi)]),
      % Don't update the process state:
      loop(Fi);
    {get, Pid} ->
      Pid ! {value, Fi},
      loop(Fi)
  end.
inc(Counter) -> Counter ! inc, ok.
dec(Counter) -> Counter ! dec, ok.
show(Counter) -> Counter ! show, ok.
get(Counter) -> Counter ! {get, self()},
  receive
    {value, Value} -> Value
  end.

% when Fi::fifo()