-module(state).
-export([start/0,start/1,inc/1,dec/1,show/1,get/1]).

start() -> spawn(fun() -> loop(0) end).
start(N) -> spawn(fun() -> loop(N) end).
loop(N) when is_integer(N) ->
  receive
    inc ->
      % Update the process state by using a new value
      % for the argument to the process loop:
      loop(N+1);
    dec ->
      % Update the process state by using a new value
      % for the argument to the process loop:
      loop(N-1);
    show ->
      io:format("N = ~w~n", [N]),
      % Don't update the process state:
      loop(N);
    {get, Pid} ->
      Pid ! {value, N},
      loop(N)
  end.
inc(Counter) -> Counter ! inc, ok.
dec(Counter) -> Counter ! dec, ok.
show(Counter) -> Counter ! show, ok.
get(Counter) -> Counter ! {get, self()},
  receive
    {value, Value} -> Value
  end.